import { Controller, Get, Req, Res, Scope, ProviderScope, Post, BodyParams } from "@tsed/common";
import { Authenticate } from "@tsed/passport";
import { Response, Request } from "express";
import { Returns } from "@tsed/schema";
import { User } from "../../entities/user/User";

@Controller("/auth")
@Scope(ProviderScope.SINGLETON)
export class AuthController {
  @Post("/github/login")
  @Authenticate("github")
  @Returns(200, User)
  async githubLogin(@Req() req: Req, @BodyParams("serviceIdentifier") serviceIdentifier: string) {
    req.query.state = serviceIdentifier;
    return req.user;
  }

  @Get("/logout")
  logout(@Req() req: Request, @Res() res: Response) {
    req.logout((err) => {
      if (err) {
        return res.status(500).send("Error logging out");
      }
      res.redirect("/");
    });
  }
}
