import { Property, Required, MaxLength, Enum, Description } from "@tsed/schema";

export class CreateLinkDto {
  @Property()
  @Required()
  @MaxLength(100)
  @Enum("github")
  service: string;

  @Property()
  @Required()
  @MaxLength(100)
  serviceIdentifier: string;

  @Property()
  @Required()
  text: string;

  @Property()
  @Required()
  @Description("The iv used to encrypt the text")
  iv: string;
}
